VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFindFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ==================================================================================================
'
' --------------------------------------------------------------------------------------------------
' -- Descripcin        : Mdulo de clase simple para buscar archivos con el Api de windows
' -- Autor              : Luciano Lodola - http://www.recursosvisualbasic.com.ar/
' --------------------------------------------------------------------------------------------------

' -- Crditos
' --------------------------------------------------------------------------------------------------
' -- La funcin base de bsqueda  :http://allapi.mentalis.org/apilist/FindFirstFile.shtml
' -- Algunas funciones para tratamiento de paths y archivos con el api : ' -- Funciones varias para Paths - http://vbnet.mvps.org/index.html?code/fileapi/pathfindextension.htm
' -- Funcin para obtener las fechas de archivos con la api FileTimeToLocalFileTime y FileTimeToSystemTime como un Date : http://www.ask-4it.com/how-to-use-findfirstfile-win32-api-from-visual-basic-code-2-ca.html
' --------------------------------------------------------------------------------------------------

' ==================================================================================================

Option Explicit
' ---------------------------------------------------------------------------------------
' -- Contantes
' ---------------------------------------------------------------------------------------
Const KB                            As Double = 1024
Const MB                            As Double = 1024 * KB
Const GB                            As Double = 1024 * MB
Const TB                            As Double = 1024 * GB
' -- Constantes de atributos de archivos para usar con GetFileAttributes y las funciones de bsqueda
Const FILE_ATTRIBUTE_ARCHIVE        As Long = &H20
Const FILE_ATTRIBUTE_DIRECTORY      As Long = &H10
Const FILE_ATTRIBUTE_HIDDEN         As Long = &H2
Const FILE_ATTRIBUTE_NORMAL         As Long = &H80
Const FILE_ATTRIBUTE_READONLY       As Long = &H1
Const FILE_ATTRIBUTE_SYSTEM         As Long = &H4
Const FILE_ATTRIBUTE_TEMPORARY      As Long = &H100
' -- Constantes para usar con la funcin Api SHGetFileInfo
Const SHGFI_TYPENAME                As Long = &H400&
Const SHGFI_DISPLAYNAME             As Long = &H200
Const DI_MASK                       As Long = &H1
Const DI_IMAGE                      As Long = &H2
Const DI_NORMAL                     As Long = DI_MASK Or DI_IMAGE
' -- Otras
Const MAX_PATH                      As Long = 260
Const MAXDWORD                      As Long = &HFFFF
Const INVALID_HANDLE_VALUE          As Long = -1

Const GWL_EXSTYLE = (-20)                       ' -- mensaje que requiere GetWindowLong
  
Const WM_USER           As Long = &H400
Const PBS_MARQUEE       As Long = 8             ' -- Estilo del progressbar ( Marquesina )
Const PBM_SETMARQUEE = (WM_USER + 10)           ' -- Mensaje - Para SendMessage
  
Const GWL_STYLE = (-16)

' -- Para la funcin buscar carpeta de windows
Const BIF_RETURNONLYFSDIRS = 1

' -- http://vbnet.mvps.org/index.html?code/disk/floppyready.htm
Const SEM_FAILCRITICALERRORS = &H1
Const SEM_NOOPENFILEERRORBOX = &H8000&

' ---------------------------------------------------------------------------------------
' -- Types y enums
' ---------------------------------------------------------------------------------------

' -- Udt requerida por la funcin FileTimeToSystemTime
Private Type SYSTEMTIME
    wYear                           As Integer
    wMonth                          As Integer
    wDayOfWeek                      As Integer
    wDay                            As Integer
    wHour                           As Integer
    wMinute                         As Integer
    wSecond                         As Integer
    wMilliseconds                   As Integer
End Type
' -- Type que requiere WIN32_FIND_DATA
Private Type FILETIME
    dwLowDateTime                   As Long
    dwHighDateTime                  As Long
End Type
' -- Type para la funcin api ShellFileInfo
Private Type ShellFileInfoType
  hIcon                             As Long
  iIcon                             As Long
  dwAttributes                      As Long
  szDisplayName                     As String * 260
  szTypeName                        As String * 80
End Type
' -- Type requerida por las funcines de bsqueda FindFirstFiles
Private Type WIN32_FIND_DATA
    dwFileAttributes                As Long
    ftCreationTime                  As FILETIME
    ftLastAccessTime                As FILETIME
    ftLastWriteTime                 As FILETIME
    nFileSizeHigh                   As Long
    nFileSizeLow                    As Long
    dwReserved0                     As Long
    dwReserved1                     As Long
    cFileName                       As String * MAX_PATH
    cAlternate                      As String * 14
End Type

Private Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type

' -- Para la funcin SHGetFileInfo
Private Type IconType
  cbSize                            As Long
  picType                           As PictureTypeConstants
  hIcon                             As Long
End Type

' -- Para la funcin SHGetFileInfo
Private Type CLSIdType
  id(16)                            As Byte
End Type

' -- Enum Para buscar archivos con un atributo exacto
Enum eAttributes
    eFILE_ATTRIBUTE_ARCHIVE = &H20
    eFILE_ATTRIBUTE_HIDDEN = &H2
    eFILE_ATTRIBUTE_NORMAL = &H80
    eFILE_ATTRIBUTE_READONLY = &H1
    eFILE_ATTRIBUTE_SYSTEM = &H4
End Enum

' -- Para devolver la fecha y hora de acceso, creacin y modificacin con la funcin GetFileDateTime
Enum eOptionDateTime
    [eDateCreation] = 0
    [eDateModified] = 1
    [eDateLastAccess] = 2
    [eTimeCreation] = 3
    [eTimeModified] = 4
    [eTimeLastAccess] = 5
    [eDateTimeCreation] = 6
    [eDateTimeModified] = 7
    [eDateTimeAccess] = 7
End Enum

Enum eFindOption
    [eComplet] = 0
    [ePartial] = 1
End Enum

' -- Tamao de conos de archivos y drives (para la funcin SHGetFileInfo)
Enum eIconSize
    eSmallIcon = 257
    eLargeIcon = 256
End Enum
' ---------------------------------------------------------------------------------------
' -- Apis
' ---------------------------------------------------------------------------------------

' -- Funciones de Bsqueda
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

' -- Funcin para Obtener atributos
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
' -- Funcin para Obtener el nombre de archivo desde el path
Private Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
' -- Para saber si un path es un directorio
Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryA" (ByVal pszPath As String) As Long
' -- Funcin para recuperar informacin varia de un archivo ( El Tipo / Descripcin, el nombre, el icono)
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As ShellFileInfoType, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
' -- Funcin para crear la imagen de cono
Private Declare Function OleCreatePictureIndirect Lib "oleaut32.dll" (pDicDesc As IconType, riid As CLSIdType, ByVal fown As Long, lpUnk As Object) As Long
' -- Funcin para extraer el cono asociado de una extensin
Private Declare Function ExtractAssociatedIcon Lib "shell32.dll" Alias "ExtractAssociatedIconA" (ByVal hInst As Long, ByVal lpIconPath As String, lpiIcon As Long) As Long
' -- Funcin para dibujar un cono en un HDC a partir del handle
Private Declare Function DrawIconEx Lib "user32" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long

' -- Funciones para obtener informacin de los drives
Private Declare Function GetLogicalDrives Lib "kernel32" () As Long
Private Declare Function GetDriveTypeApi Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function SHGetDiskFreeSpace Lib "shell32" Alias "SHGetDiskFreeSpaceA" (ByVal pszVolume As String, pqwFreeCaller As Currency, pqwTot As Currency, pqwFree As Currency) As Long

' -- Funciones varias para trabajr con paths
Private Declare Function PathCompactPathEx Lib "shlwapi.dll" Alias "PathCompactPathExA" (ByVal pszOut As String, ByVal pszSrc As String, ByVal cchMax As Long, ByVal dwFlags As Long) As Long
Private Declare Function PathFindExtension Lib "shlwapi" Alias "PathFindExtensionA" (ByVal pPath As String) As Long
Private Declare Function PathStripToRoot Lib "shlwapi" Alias "PathStripToRootA" (ByVal pPath As String) As Long
Private Declare Function lstrcpyA Lib "kernel32" (ByVal RetVal As String, ByVal Ptr As Long) As Long
Private Declare Function lstrlenA Lib "kernel32" (ByVal Ptr As Any) As Long
' -- Funciones para trabajar con las fechas
Private Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
' -- Funcin para acceder a informacin de un volumen
Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long

' -- Funciones para el dlg Seleccionar directorio
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
' -- Retorna el exe/programa asociado a un archivo
Private Declare Function FindExecutable Lib "shell32.dll" Alias "FindExecutableA" (ByVal lpFile As String, ByVal lpDirectory As String, ByVal lpResult As String) As Long


' ---------------------------------------------------------------------------------------
' -- Eventos
' ---------------------------------------------------------------------------------------

Event GetFile(ByVal sFileName As String)   ' -- Recibe los archivos de a 1
Event InitSearch()                                                  ' -- Antes de buscar
Event EndSearch()                                                   ' -- Fin
' ---------------------------------------------------------------------------------------
' -- Variables
' ---------------------------------------------------------------------------------------
Private mFilesCount             As Long                 ' -- Cantidad de archivos
Private mDirCount               As Long                 ' -- Cantidad de directorios
Private mTotalSize              As Double               ' -- Total de bytes del directorio (incluyendo subdirs si mSearchSubDirs = true)
Private mColFiles               As Collection           ' -- Coleccin con los archivos, drives y extensiones
Private mColDrives              As Collection
Private mSearchSubDirs          As Boolean              ' -- Incluir o no subdirectorios

Private mMaxFileSize            As Currency             ' -- Tamao mximo del archivo
Private mMinFileSize            As Currency             ' -- Tamao mnimo del archivo
Private mStopSearch             As Boolean              ' -- Detener bsqueda
Private mAttributes             As eAttributes          ' -- Atributos del archivo
Private mFindOption             As eFindOption          ' -- Buscar el nombre de archivo completo o parcial
Private mArrExt()               As String               ' -- Array con las extensiones
Private mFileName               As String               ' -- Buscar archivos por el nombre o parte

Private mDateCreationTo         As Date                 ' -- Fecha de inicio de creacin de archivo
Private mDateCreationFrom       As Date                 ' -- Fecha final de creacin de archivo
Private mDateLastModifiedFrom   As Date                 ' -- Fecha inicial de modificacin
Private mDateLastModifiedTo     As Date                 ' -- Fecha final de modificacin
Private mDateLastAccessFrom     As Date                 ' -- Fecha inicial de ltimo acceso
Private mDateLastAccessTo       As Date                 ' -- Fecha final de ltimo acceso


' ---------------------------------------------------------------------------------------
' \\ -- Inicio del mdulo - Inicializar variables
' ---------------------------------------------------------------------------------------
Private Sub Class_Initialize()
    mSearchSubDirs = True
    Set mColFiles = New Collection
    Set mColDrives = New Collection
    Set mColDrives = pvGetDrives
    Call SetErrorMode(SEM_FAILCRITICALERRORS)
End Sub

' ---------------------------------------------------------------------------------------
' \\ -- Eliminar variables y liberar recursos al destruir la instancia
' ---------------------------------------------------------------------------------------
Private Sub Class_Terminate()
    Set mColFiles = Nothing
    Set mColDrives = Nothing
    Erase mArrExt
End Sub

' =======================================================================================
' \\ -- Funciones pblicas
' =======================================================================================

' ----------------------------------------------------------------------------------
' \\ -- Funcin que devuelve la fecha/Hora de creacin, acceso y modificacin de un archivo
' ----------------------------------------------------------------------------------
Function GetFileDateTime(ByVal sPath As String, lOptionDate As eOptionDateTime) As Date

    Dim hFile           As Long
    Dim wfd             As WIN32_FIND_DATA
    
    ' -- Acceder al archivo y devolver en wfd los datos
    hFile = FindFirstFile(sPath, wfd)
    
    ' -- Comprobar que se pudo acceder, si no salir de la funcin ..
    If hFile = INVALID_HANDLE_VALUE Then Exit Function
    
    Call FindClose(hFile)
    
    ' -- Formatear y retornar la fecha / hora de acuerdo a lOptionDate
    Select Case lOptionDate
        
        ' -- Fechas
        Case 0: GetFileDateTime = FormatDateTime(pvFileTimeToDate(wfd.ftCreationTime), vbShortDate)
        Case 1: GetFileDateTime = FormatDateTime(pvFileTimeToDate(wfd.ftLastWriteTime), vbShortDate)
        Case 2: GetFileDateTime = FormatDateTime(pvFileTimeToDate(wfd.ftLastAccessTime), vbShortDate)
        
        ' -- Horas
        Case 3: GetFileDateTime = FormatDateTime(pvFileTimeToDate(wfd.ftCreationTime), vbShortTime)
        Case 4: GetFileDateTime = FormatDateTime(pvFileTimeToDate(wfd.ftLastWriteTime), vbShortTime)
        Case 5: GetFileDateTime = FormatDateTime(pvFileTimeToDate(wfd.ftLastAccessTime), vbShortTime)
        
        ' -- Fecha + Hora
        Case 6: GetFileDateTime = pvFileTimeToDate(wfd.ftCreationTime)
        Case 7: GetFileDateTime = pvFileTimeToDate(wfd.ftLastWriteTime)
        Case 8: GetFileDateTime = pvFileTimeToDate(wfd.ftLastAccessTime)
    End Select
End Function
' ----------------------------------------------------------------------------------
' \\ -- Funcin de entrada para comenzar a buscar
' ----------------------------------------------------------------------------------
Sub Find( _
    ByVal sDirPath As String, _
    Optional ByVal sPattern As String, _
    Optional ByVal sFileName As String, _
    Optional lFindOption As eFindOption = 1)

    On Error GoTo error_handler
    
    ' -- Comprobar caracteres invlidos del archivo
    If (InStr(sFileName, "\")) Or _
       (InStr(sFileName, "/")) Or _
       (InStr(sFileName, ":")) Or _
       (InStr(sFileName, "?")) Or _
       (InStr(sFileName, "<")) Or _
       (InStr(sFileName, ">")) Or _
       (InStr(sFileName, "|")) Or _
       (InStr(sFileName, "*")) Then
       
       MsgBox "El nombre de archivo no puede contener ninguno de estos caracteres : / \ * ? : | < > ", vbCritical, "Error en nombre de archivo"
       RaiseEvent EndSearch
       Exit Sub
    
    End If
    
    ' -- Setear variables
    mFilesCount = 0
    mDirCount = 0
    mTotalSize = 0
    mStopSearch = False
    mFileName = sFileName
    mFindOption = lFindOption
    ReDim mArrExt(0)
    
    ' -- Setear coleccin de archivos
    Set mColFiles = Nothing
    Set mColFiles = New Collection
    
    ' -- Setear filtros de extensiones
    If Right(sPattern, 1) <> ";" Then
        sPattern = sPattern & ";"
    End If
    
    ' -- Obtener las extensiones en un array
    mArrExt = Split(sPattern, ";")
    If mArrExt(UBound(mArrExt)) = vbNullString And UBound(mArrExt) > 0 Then
        ReDim Preserve mArrExt(UBound(mArrExt) - 1)
    End If
    
    ' -- Quitar los *.
    If UBound(mArrExt) > 0 Then
       Dim i As Integer
       For i = 0 To UBound(mArrExt)
          mArrExt(i) = Replace(mArrExt(i), "*.", vbNullString)
       Next
    End If
    
    ' -- Si no se pas el criterio como parmetro buscar todos ( usar *.* )
    If UBound(mArrExt) = 0 And mArrExt(0) = vbNullString Then
       mArrExt(0) = "*.*"
    End If
    
    ' -- Lanzar evento de inicio antes de comenzar a buscar
    RaiseEvent InitSearch
    
    ' -- Comenzar a buscar en esta ruta
    If sDirPath <> vbNullString Then
        Call pvFindFilesAPI(sDirPath)
    Else
    ' -- Si no se pasa el path, buscar en todas las unidades
        Dim xDrive  As Variant
        ' -- Recorrer los drives
        For Each xDrive In mColDrives
            DoEvents
            ' -- Enviar la unidad y buscar
            Call pvFindFilesAPI(CStr(xDrive))
        Next
    End If
    
    ' -- FIN de bsqueda
    DoEvents
    RaiseEvent EndSearch
    mStopSearch = False
        
    ' -- Error
    Exit Sub
error_handler:
    MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    RaiseEvent EndSearch
End Sub
' ----------------------------------------------------------------------------------
' \\ -- Detener bsqueda
' ----------------------------------------------------------------------------------
Public Sub StopSearch()
    DoEvents
    mStopSearch = True
End Sub
' -----------------------------------------------------------------------------------------
' \\ -- Obtener espacio total y libre de una unidad
' -----------------------------------------------------------------------------------------
Function GetDiskFreeSpace(ByVal sDrive As String, Optional FreeSpace As Currency, Optional TotalSpace As Currency) As Currency
    Dim FreeCaller      As Currency
    Dim Tot             As Currency
    Dim free            As Currency
    Dim lRet            As Long
    
    Screen.MousePointer = vbHourglass
    ' -- Verificar la barra separadora de path
    If Right(sDrive, 2) <> ":\" Then sDrive = sDrive & ":\"
    
    lRet = SHGetDiskFreeSpace(sDrive, FreeCaller, Tot, free)
    
    TotalSpace = Tot * 10000
    FreeSpace = free * 10000
    
    Screen.MousePointer = vbDefault
End Function
' -----------------------------------------------------------------------------------------
' \\ -- Funcin para compactar una ruta cuando es muy larga
' -----------------------------------------------------------------------------------------
Function CompactPath(ByVal sPath, Optional lMaxChar As Long = 50) As String

    Dim ret             As Long
    Dim sBuffer         As String * 256
    ' Enviar la ruta, la cantidad de caracteres, y enviar el buffer para retornar el path compactado
    ret = PathCompactPathEx(sBuffer, sPath, lMaxChar, 0)
    If InStr(sBuffer, Chr(0)) > 0 Then CompactPath = Left(sBuffer, InStr(sBuffer, Chr(0)) - 1)
End Function
' -----------------------------------------------------------------------------------------
' \\ -- Dibujar en un Hdc el cono asociado a un tipo de fichero o el cono de un Drive
' -----------------------------------------------------------------------------------------
Function DrawIcon(SpathFile As String, lHdc As Long, Optional x As Long = 0, Optional y As Long = 0, Optional lWidth As Long = 32, Optional lHeight As Long = 32) As Boolean
    On Error GoTo error_function
    
    Dim hIcon As Long
    ' -- Obtener el handle del cono
    hIcon = ExtractAssociatedIcon(App.hInstance, SpathFile, 0)
    ' -- Pasar el handle, las dimensiones y el HDC para dibujar el cono
    DrawIcon = DrawIconEx(lHdc, x, y, hIcon, lWidth, lHeight, 0, 0, DI_NORMAL)
    ' -- Liberar
    DestroyIcon hIcon
Exit Function
error_function:
End Function

' -----------------------------------------------------------------------------------------
' \\ -- Recuperar info de un drive
' -----------------------------------------------------------------------------------------
Sub GetDriveInfo(ByVal sDrive As String, Optional lSerialNumber As Long, Optional sLabel As String, Optional sFileSystem As String)
    On Error GoTo error_handler
    
    Dim lRet As Long
    
    If Len(sDrive) = 1 Then sDrive = sDrive & ":\"
    If Len(sDrive) = 2 Then sDrive = sDrive & "\"
    
    sLabel = String(255, Chr(0))
    sFileSystem = String(255, Chr(0))
    
    lRet = GetVolumeInformation(sDrive, sLabel, Len(sLabel), lSerialNumber, 0, 0, sFileSystem, Len(sFileSystem))
    If lRet Then
        sLabel = Left(sLabel, InStr(sLabel, Chr(0)) - 1)
        sFileSystem = Left(sFileSystem, InStr(sFileSystem, Chr(0)) - 1)
    End If
    
    Exit Sub
error_handler:
End Sub

' -----------------------------------------------------------------------------------------
' \\ -- Devuelve el programa ejecutable por defecto asociado a un archivo usando la funcin FindExecutable
' -----------------------------------------------------------------------------------------
Function GetExecutable(ByVal sPath As String) As String
    On Error GoTo error_handler
    Dim sBuffer     As String
    Dim lRet        As Long
    ' -- crear un buffer para obtener el path del exe
    sBuffer = String(256, Chr(0))
    ' -- Pasar el path del archivo y el buffer
    lRet = FindExecutable(sPath, vbNullString, sBuffer)
    ' -- Devolver el path del programa sin los nulos
    If lRet Then GetExecutable = Left(sBuffer, InStr(sBuffer, Chr(0)) - 1)
    Exit Function
error_handler:
    
End Function

' -----------------------------------------------------------------------------------------
' \\ -- Devuelve True si se puede acceder a un drive
' -----------------------------------------------------------------------------------------
Function DriveIsReady(ByVal sDrive As String) As Boolean
    Screen.MousePointer = vbHourglass
    
    If Len(sDrive) = 1 Then sDrive = sDrive & ":\"
    If Len(sDrive) = 2 Then sDrive = sDrive & "\"
    
    DriveIsReady = GetVolumeInformation(sDrive, vbNullString, 0, 0, 0, 0, vbNullString, 0)
    Screen.MousePointer = vbDefault
End Function

' -----------------------------------------------------------------------------------------
' \\ -- Devolver el cono de un archivo como IPictureDisp
' -----------------------------------------------------------------------------------------
Function LoadIcon(lIconSize As eIconSize, sFileName As String) As IPictureDisp
    Dim ret         As Long
    Dim Unkown      As IUnknown
    Dim Icon        As IconType
    Dim CLSID       As CLSIdType
    Dim ShellInfo   As ShellFileInfoType
    
    Call SHGetFileInfo(sFileName, 0, ShellInfo, Len(ShellInfo), lIconSize)
    With Icon
        .cbSize = Len(Icon)
        .picType = 3
        .hIcon = ShellInfo.hIcon
    End With
    With CLSID
        .id(8) = &HC0
        .id(15) = &H46
    End With
    ret = OleCreatePictureIndirect(Icon, CLSID, 1, Unkown)
    Set LoadIcon = Unkown
End Function
' -----------------------------------------------------------------------------------------
' \\ -- Devolver tipo de unidad como string
'    -- + info -> http://msdn.microsoft.com/en-us/library/aa364939.aspx
' -----------------------------------------------------------------------------------------
Function GetDriveType(ByVal sDrive As String) As String
    If Right(sDrive, 2) <> ":\" Then sDrive = sDrive & ":\"
    
    Select Case GetDriveTypeApi(sDrive)
        Case 0: GetDriveType = "DRIVE_UNKNOWN"
        Case 1: GetDriveType = "DRIVE_NO_ROOT_DIR"
        Case 2: GetDriveType = "DRIVE_REMOVABLE"
        Case 3: GetDriveType = "DRIVE_FIXED"
        Case 4: GetDriveType = "DRIVE_REMOTE"
        Case 5: GetDriveType = "DRIVE_CDROM"
        Case 6: GetDriveType = "DRIVE_RAMDISK"
    End Select
End Function
' ----------------------------------------------------------------------------------
' \\ -- Devolver true/False si el path es un directorio
' ----------------------------------------------------------------------------------
Function IsDirectory(sPath As String) As Boolean
    IsDirectory = PathIsDirectory(sPath)
End Function
' ----------------------------------------------------------------------------------
' \\ -- Devolver True si un archivo existe
' ----------------------------------------------------------------------------------
Public Function FileExist(ByVal strFile As String) As Boolean
  
    Dim lHandle As Long             ' Handle del archivo
    Dim wfd As WIN32_FIND_DATA      ' udt con los datos
       
    ' Comprobar la barra separadora de path y la longitud, si no tiene la barra agregarla
    If ((Len(strFile) > 3) And (Right$(strFile, 1) = "\")) Then
        strFile = Left$(strFile, Len(strFile) - 1)
    End If
    lHandle = FindFirstFile(strFile, wfd) ' buscar
    ' --  si el cdigo del handle es vlido, distinto de -1, devolver true ...
    FileExist = lHandle <> INVALID_HANDLE_VALUE
    '  -- cerrar
    Call FindClose(lHandle)
  
End Function




' ----------------------------------------------------------------------------------
' \\ -- Formatear el tamao expresado en Bytres a: -- KB, MB, GB, y devolverlo como string
' ----------------------------------------------------------------------------------
Function GetFormatSize(ByVal n_bytes As Double) As String
    If n_bytes < KB Then
        GetFormatSize = Format$(n_bytes) & " bytes"
    ElseIf n_bytes < MB Then
        GetFormatSize = Format$(n_bytes / KB, "0.00") & " KB"
    ElseIf n_bytes < GB Then
        GetFormatSize = Format$(n_bytes / MB, "0.00") & " MB"
    Else
        GetFormatSize = Format$(n_bytes / GB, "0.00") & " GB"
    End If
End Function
' ----------------------------------------------------------------------------------
' \\ -- Devolver un string con la descripcin del tipo de archivo
' ----------------------------------------------------------------------------------
Function GetFileType(ByVal sPath As String) As String
  Dim ret   As Long
  Dim FI    As ShellFileInfoType
  ' -- Enviar la ruta, y el flag SHGFI_TYPENAME para obtener la descripcin del tipo de archivo
  Call SHGetFileInfo(sPath, 0, FI, Len(FI), SHGFI_TYPENAME)
  ' -- Obtener la posicin del primer Char Null
  ret = InStr(1, FI.szTypeName, Chr$(0)) - 1
  ' -- Retornar sin nulos
  GetFileType = Left(FI.szTypeName, ret)
End Function
' -----------------------------------------------------------------
' \\ -- Abrir dilogo para seleccin de carpeta
' -----------------------------------------------------------------

Function BrowseForFolder(lHwndOwner As Long, sTitle As String) As String

    Dim Id_List         As Long
    Dim sBuffer         As String
    Dim BI              As BrowseInfo
    
    With BI
        ' -- hwnd del frm
        .hwndOwner = lHwndOwner
        ' -- Establecemos la leyenda del cuadro y Retorna la direccin de memoria
        .lpszTitle = lstrcat(sTitle, "")
        ' -- Retornar solo si el usuario selecciona un dir
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With
    ' -- Mostrar el cuadro de dialogo Buscar carpeta
    Id_List = SHBrowseForFolder(BI)
    
    If Id_List Then
        ' -- Buffer para el path
        sBuffer = String$(MAX_PATH, 0)
        ' -- Obtener el path en el buffer
        Call SHGetPathFromIDList(Id_List, sBuffer)
        Call CoTaskMemFree(Id_List)
        ' -- Retornar el path
        sBuffer = Left$(sBuffer, InStr(sBuffer, vbNullChar) - 1)
        If Len(sBuffer) Then BrowseForFolder = sBuffer
    End If
End Function




' -----------------------------------------------------------------
' \\ -- Devolver el nombre del archivo desde la ruta completa
' -----------------------------------------------------------------
Function GetFileName(ByVal sPath As String)
On Error GoTo error_handler
    
    ' -- Crear buffer de caracteres
    Dim sBuffer As String
    sBuffer = String(255, 0)
    
    ' -- Enviar el Buffer de caracteres, el path y retornar el FileName en el buffer
    Call GetFileTitle(sPath, sBuffer, Len(sBuffer))
    GetFileName = Left$(sBuffer, InStr(1, sBuffer, Chr$(0)) - 1)
    
    Exit Function
error_handler:
End Function
' -----------------------------------------------------------------
' \\ -- Extraer la extensin desde la ruta completa
' -----------------------------------------------------------------
Function GetExtension(ByVal sPath As String) As String
  Dim sTemp As String
  'Given a path and filename, return only the filename extension.
  sTemp = pvGetStrFromPtrA(PathFindExtension(sPath))
  
  If Len(sTemp) Then GetExtension = Replace(sTemp, ".", vbNullString)
End Function
' ----------------------------------------------------------------------------------
' \\ -- Obtener la unidad de un path
' ----------------------------------------------------------------------------------
Function GetDriveFromPath(ByVal sPath As String) As String
    Dim lRet As Long
    ' -- Pasar el path al api
    lRet = PathStripToRoot(sPath)
    ' -- Quitar nulos y retornar
    If lRet Then GetDriveFromPath = pvTrimNull(sPath)
End Function
' =======================================================================================
' -- Funciones privadas
' =======================================================================================
' ----------------------------------------------------------------------------------
' \\ -- Funcin usada por GetExtension
' ----------------------------------------------------------------------------------
Private Function pvGetStrFromPtrA(ByVal lpszA As Long) As String
  
  'Given a pointer to a string, return the string
   pvGetStrFromPtrA = String$(lstrlenA(ByVal lpszA), 0)
   Call lstrcpyA(ByVal pvGetStrFromPtrA, ByVal lpszA)
End Function
' ----------------------------------------------------------------------------------
' \\ -- Eliminar nulos de las cadenas devueltas por algunas funciones apis
' ----------------------------------------------------------------------------------
Private Function pvTrimNull(sPath As String) As String
    If (InStr(sPath, Chr(0)) > 0) Then
        sPath = Left(sPath, InStr(sPath, Chr(0)) - 1)
    End If
    pvTrimNull = sPath
End Function

' ----------------------------------------------------------------------------------
' \\ -- Funcin recursiva de bsqueda
' ----------------------------------------------------------------------------------
Private Sub pvFindFilesAPI(Optional sDirPath As String)

    On Error GoTo error_handler

    Dim i                   As Long
    Dim j                   As Integer
    Dim sFileName           As String                  ' -- Variable para el path del archivo
    Dim sDirName            As String                  ' -- Variable para el path del Directorio
    Dim dirNames()          As String                  ' -- Array que mantiene los dirs
    Dim nDir                As Long                    ' -- Variable contador para el bucle FOR que hace la recursividad
    Dim hSearch             As Long                    ' -- Handle de los archivos
    Dim wfd                 As WIN32_FIND_DATA         ' -- Estructura con los datos del archivo/Dir
    Dim Cont                As Long
    Dim curFileSize         As Currency                ' -- Tamao actual del archivo
    Dim FileCreation        As Date
    Dim FileLastModified    As Date
    Dim FileLastAccess      As Date
    
    ' -- Verificar si se detiene la bsqueda
    If mStopSearch Then Exit Sub
    DoEvents
    
    ' -- Verificar la barra separadora de path, si no est agregarla
    If Right(sDirPath, 1) <> "\" Then sDirPath = sDirPath & "\"
    
    ' ---------------------------------------------------------------
    ' -- Buscar subdirectorios
    ' ---------------------------------------------------------------
    If mSearchSubDirs Then
        nDir = 0
        ReDim dirNames(nDir)
        Cont = True
        ' -- Buscar el primer archivo o carpeta
        hSearch = FindFirstFile(sDirPath & "*", wfd)
        ' -- Si hSearch es -1, es por que no hay mas o hubo un error
        If hSearch <> INVALID_HANDLE_VALUE Then
            Do While Cont
                ' -- Devolver el Archivo o carpeta sin nulos
                sDirName = pvTrimNull(wfd.cFileName)
                ' Pasar del directorio actual y del parent
                If (sDirName <> ".") And (sDirName <> "..") Then
                    ' Si es una carpeta .... (con la constante de atributo --> FILE_ATTRIBUTE_DIRECTORY)
                    If GetFileAttributes(sDirPath & sDirName) And FILE_ATTRIBUTE_DIRECTORY Then
                        ' -- Guardar en el array para buscar despus
                        dirNames(nDir) = sDirName
                        mDirCount = mDirCount + 1
                        nDir = nDir + 1
                        ReDim Preserve dirNames(nDir)
                    End If
                End If
                ' -- Seguir buscando hasta encontrar mas directorios
                Cont = FindNextFile(hSearch, wfd)
            Loop
            
            ' Fin
            ' -- Cerrar el ltimo handle abierto
            Cont = FindClose(hSearch)
        End If
    End If
    ' ---------------------------------------------------------------
    ' -- Buscar Archivos en el dir actual
    ' ---------------------------------------------------------------
    ' -- Sin hay una  sola extensin, pasar el elemento 1 del array, sino pasar *.* y luego comparar en un bucle
    If UBound(mArrExt) = 0 Then
        hSearch = FindFirstFile(sDirPath & mArrExt(0), wfd)
    Else
        hSearch = FindFirstFile(sDirPath & "*.*", wfd)
    End If
    Cont = True
    
    ' -- Verificar que hay archivos o que no hubo error
    If hSearch <> INVALID_HANDLE_VALUE Then
        While Cont
            ' -- Devolver el path sin los nulos
            sFileName = pvTrimNull(wfd.cFileName)
            ' -- Ignorar el directorio actual y el de nivel superior
            If (sFileName <> ".") And (sFileName <> "..") Then
                
                ' -- Tamao del archivo en bytes
                curFileSize = (wfd.nFileSizeHigh * MAXDWORD) + wfd.nFileSizeLow
                
                ' -- Guardar fechas de archivos
                FileCreation = FormatDateTime(pvFileTimeToDate(wfd.ftCreationTime), vbShortDate)
                FileLastModified = FormatDateTime(pvFileTimeToDate(wfd.ftLastWriteTime), vbShortDate)
                FileLastAccess = FormatDateTime(pvFileTimeToDate(wfd.ftLastAccessTime), vbShortDate)
                
                ' -- Comprobar los tamaos
                If (curFileSize >= mMinFileSize Or mMinFileSize = 0) And _
                   (curFileSize <= mMaxFileSize Or mMaxFileSize = 0) And _
                   (wfd.dwFileAttributes = mAttributes Or mAttributes = 0) Then
                        ' -- Comprobar fechas
                        If (FileCreation >= mDateCreationFrom Or mDateCreationFrom = 0) And _
                           (FileCreation <= mDateCreationTo Or mDateCreationTo = 0) And _
                           (FileLastModified <= mDateLastModifiedTo Or mDateLastModifiedTo = 0) And _
                           (FileLastModified >= mDateLastModifiedFrom Or mDateLastModifiedFrom = 0) And _
                           (FileLastAccess <= mDateLastAccessTo Or mDateLastAccessTo = 0) And _
                           (FileLastAccess >= mDateLastAccessFrom Or mDateLastAccessFrom = 0) Then
                   
                            ' -- Buscar todos
                            If UBound(mArrExt) = 0 Then
                                Call pvAddFile(sDirPath & sFileName, curFileSize)
                                ' -- Recorrer el array de extensiones y comparar con el archivo actual
                            Else
                                For j = 0 To UBound(mArrExt)
                                    ' -- Comparar la extensin, ..si es igual, agregar el archivo
                                    If LCase(GetExtension(sDirPath & sFileName)) = LCase(mArrExt(j)) Then
                                        Call pvAddFile(sDirPath & sFileName, curFileSize)
                                        Exit For
                                    End If
                                Next
                            End If
                        End If
                        
                End If
            End If
            
            ' -- Buscar Siguiente
            Cont = FindNextFile(hSearch, wfd)
        Wend
        
        Cont = FindClose(hSearch)
    End If
    
    ' -- Bucle recursivo para buscar mas carpetas y archivos en los subdirectorios guardados en dirNames
    If nDir > 0 Then
        For i = 0 To nDir - 1
            Call pvFindFilesAPI(sDirPath & dirNames(i) & "\")
        Next i
    End If
    
    Exit Sub
error_handler:

    Debug.Print "Descripcin: "; Err.Description & " -- " & " Error: " & Err.Number
    
End Sub
' -----------------------------------------------------------------------------------------
' \\ -- Retorna True si se encuentra parte del texto en el nombre del archivo ( sin incluir la extensin )
' -----------------------------------------------------------------------------------------
Private Function pvCheckFileName(ByVal sFileName As String) As Boolean
    If Not IsDirectory(sFileName) Then
        sFileName = LCase(GetFileName(sFileName))
        If InStr(sFileName, ".") Then
            sFileName = Left(sFileName, InStrRev(sFileName, ".") - 1)
        End If
        If mFindOption = ePartial Then
            If InStr(sFileName, LCase(mFileName)) > 0 Then pvCheckFileName = True
        Else
            If Trim(LCase(mFileName)) = Trim(LCase(sFileName)) Then
                pvCheckFileName = True
            End If
        End If
    End If
End Function
' -----------------------------------------------------------------------------------------
' \\ -- Devolver Coleccin con las unidades
' -----------------------------------------------------------------------------------------
Private Function pvGetDrives() As Collection
    Dim LDs         As Long
    Dim Cnt         As Long
    Dim sDrive      As String
    Dim tempCol     As Collection
    
    Set tempCol = New Collection
    
    LDs = GetLogicalDrives
    For Cnt = 0 To 25
        If (LDs And 2 ^ Cnt) <> 0 Then
           sDrive = CStr(Chr$(65 + Cnt))
           
           If Right(sDrive, 2) <> ":\" Then sDrive = sDrive & ":\"
           
           tempCol.Add sDrive
        End If
    Next Cnt
    
    Set pvGetDrives = tempCol
    Set tempCol = Nothing
    
End Function


' -----------------------------------------------------------------------------------------
' \\ -- Devolver Coleccin con las extensiones
' -----------------------------------------------------------------------------------------
Private Function pvGetExtensions() As Collection
On Error GoTo error_handler
    Dim tempCol     As Collection
    Dim i           As Integer
    
    Set tempCol = New Collection
    For i = 0 To UBound(mArrExt)
        If Len(mArrExt(i)) Then tempCol.Add mArrExt(i)
    Next
    Set pvGetExtensions = tempCol
    Set tempCol = Nothing
    
    Exit Function
error_handler:
    
End Function


' ----------------------------------------------------------------------------------
' \\ -- Sub para agregar el archivo a la coleccin y enviar el evento GetFile con el archivo actual
' ----------------------------------------------------------------------------------
Private Sub pvAddFile(sFile As String, curFileSize As Currency)
    
On Error GoTo error_handler
    
    If pvCheckFileName(sFile) Then
        ' -- Guardar tamao
        mTotalSize = mTotalSize + curFileSize
        ' -- Guardar cantidad de archivos
        mFilesCount = mFilesCount + 1
        ' -- Lanzar evento para enviar el archivo
        RaiseEvent GetFile(sFile)
        ' -- Guardarlo tambin en la coleccin para poder accederlo desde ColFiles una ves que se termin
        Call mColFiles.Add(sFile)
    End If
    
    Exit Sub
error_handler:
    MsgBox Err.Description, vbCritical, "Error: " & CStr(Err.Number)
    RaiseEvent EndSearch
End Sub

' ----------------------------------------------------------------------------------
' \\ -- Devuelve un valor Date de acuerdo a los datos de fecha contenidos en el UDT ftLastAccessTime, ftLastWriteTime y ftLastCreationTime
' ----------------------------------------------------------------------------------
Private Function pvFileTimeToDate(lpFileTime As FILETIME) As Date
    Dim lpLocalFileTime As FILETIME
    Dim lpSystemTime As SYSTEMTIME
    Dim dResult As Date
    dResult = Empty
    ' Convert from UTC-based to the local file time
    If FileTimeToLocalFileTime(lpFileTime, lpLocalFileTime) Then
        ' Unpack FILETIME structure to SYSTEMTIME structure
        If FileTimeToSystemTime(lpLocalFileTime, lpSystemTime) Then
            ' Create Visual Basic Date value
            dResult = DateSerial(lpSystemTime.wYear, _
                lpSystemTime.wMonth, lpSystemTime.wDay) _
                + TimeSerial(lpSystemTime.wHour, _
                lpSystemTime.wMinute, lpSystemTime.wSecond)
        End If
    End If
    pvFileTimeToDate = dResult

End Function

' =======================================================================================
' \\ -- Propiedades
' =======================================================================================
' ---------------------------------------------------------------------------------------
' \\ -- Coleccin de archivos
' ---------------------------------------------------------------------------------------
Property Get ColFiles() As Collection
    Set ColFiles = mColFiles
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Coleccin de Drives
' ---------------------------------------------------------------------------------------
Property Get ColDrives() As Collection
    Set ColDrives = mColDrives
End Property

' ---------------------------------------------------------------------------------------
' \\ -- Coleccin de extensiones
' ---------------------------------------------------------------------------------------
Property Get ColExtensions() As Collection
    Set ColExtensions = pvGetExtensions
End Property

' ---------------------------------------------------------------------------------------
' \\ -- Cantidad de archivos encontrados
' ---------------------------------------------------------------------------------------
Property Get FilesCount() As Long
    FilesCount = mFilesCount
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Cantidad de directorios en donde se busc
' ---------------------------------------------------------------------------------------
Property Get DirCount() As Long
    DirCount = mDirCount
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Tamao total en bytes de la lista de archivos
' ---------------------------------------------------------------------------------------
Property Get TotalSize() As Double
    TotalSize = mTotalSize
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Buscar o no en subdirectorios
' ---------------------------------------------------------------------------------------
Property Get SearchSubDirs() As Boolean
    SearchSubDirs = mSearchSubDirs
End Property
Property Let SearchSubDirs(bvalue As Boolean)
    mSearchSubDirs = bvalue
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Tamao mximo del archivo
' ---------------------------------------------------------------------------------------
Property Get MaxFileSize() As Currency
    MaxFileSize = mMaxFileSize
End Property
Property Let MaxFileSize(CurValue As Currency)
    If (CurValue < mMinFileSize) And mMinFileSize <> 0 And CurValue <> 0 Then
       MsgBox "El valor mximo no puede ser menor al valor mnimo. cambie el valor de MinFileSize.", vbExclamation
       mMaxFileSize = 0
    Else
       mMaxFileSize = CurValue
    End If
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Tamao mnimo del archivo
' ---------------------------------------------------------------------------------------
Property Get MinFileSize() As Currency
    MinFileSize = mMinFileSize
End Property
Property Let MinFileSize(CurValue As Currency)
    If (CurValue > mMaxFileSize) And (mMaxFileSize <> 0) And CurValue <> 0 Then
       MsgBox "El valor mnimo no puede ser mayor al valor mximo. Cambie el valor de MaxFileSize.", vbExclamation
       mMinFileSize = 0
    Else
       mMinFileSize = CurValue
    End If
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Fechas de Creacin - Desde y hasta
' ---------------------------------------------------------------------------------------
Property Get DateCreationTo() As Date
    DateCreationTo = mDateCreationTo
End Property
Property Let DateCreationTo(dValue As Date)
    mDateCreationTo = dValue
End Property
Property Get DateCreationFrom() As Date
    DateCreationFrom = mDateCreationFrom
End Property

Property Let DateCreationFrom(dValue As Date)
    mDateCreationFrom = dValue
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Fechas de modificacin - Desde y hasta
' ---------------------------------------------------------------------------------------

Property Get DateLastModifiedFrom() As Date
    DateLastModifiedFrom = mDateLastModifiedFrom
End Property
Property Let DateLastModifiedFrom(dValue As Date)
    mDateLastModifiedFrom = dValue
End Property
Property Get DateLastModifiedTo() As Date
    DateLastModifiedTo = mDateLastModifiedTo
End Property
Property Let DateLastModifiedTo(dValue As Date)
    mDateLastModifiedTo = dValue
End Property
' ---------------------------------------------------------------------------------------
' \\ -- Fechas de Acceso - Desde y hasta
' ---------------------------------------------------------------------------------------
Property Get DateLastAccessTo() As Date
    DateLastAccessTo = mDateLastAccessTo
End Property
Property Let DateLastAccessTo(dValue As Date)
    mDateLastAccessTo = dValue
End Property
Property Get DateLastAccessFrom() As Date
    DateLastAccessFrom = mDateLastAccessFrom
End Property
Property Let DateLastAccessFrom(dValue As Date)
    mDateLastAccessFrom = dValue
End Property
' ---------------------------------------------------------------------------------------
' \\ -- para el atributo de archivo
' ---------------------------------------------------------------------------------------
Property Get Attributes() As eAttributes
    Attributes = mAttributes
End Property
Property Let Attributes(lValue As eAttributes)
    mAttributes = lValue + eFILE_ATTRIBUTE_ARCHIVE
End Property
